OGRE-Next: Ogre::RaySceneQuery Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::RaySceneQuery Class Referenceabstract
Core | Component » Scene

Specialises the SceneQuery class for querying along a ray. More...

`#include <OgreSceneQuery.h>`

Inheritance diagram for Ogre::RaySceneQuery:
[legend]

## Public Member Functions
| RaySceneQuery (SceneManager *mgr)
| ~RaySceneQuery () override
virtual void | clearResults ()
| Clears the results of the last query execution.
virtual RaySceneQueryResult & | execute ()
| Executes the query, returning the results back in one list.
virtual void | execute (RaySceneQueryListener *listener)=0
| Executes the query and returns each match through a listener interface.
virtual RaySceneQueryResult & | getLastResults ()
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.
virtual ushort | getMaxResults () const
| Gets the maximum number of results returned from the query (only relevant if results are being sorted)
virtual const Ray & | getRay () const
| Gets the ray which is to be used for this query.
virtual bool | getSortByDistance () const
| Gets whether the results are sorted by distance.
bool | queryResult (MovableObject *obj, Real distance) override
| Self-callback in order to deal with execute which returns collection.
bool | queryResult (SceneQuery::WorldFragment *fragment, Real distance) override
| Self-callback in order to deal with execute which returns collection.
virtual void | setRay (const Ray &ray)
| Sets the ray which is to be used for this query.
virtual void | setSortByDistance (bool sort, ushort maxresults=0)
| Sets whether the results of this query will be sorted by distance along the ray.
Public Member Functions inherited from Ogre::SceneQuery
| SceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~SceneQuery ()
virtual uint32 | getQueryMask () const
| Returns the current mask for this query.
virtual const set< WorldFragmentType >::type * | getSupportedWorldFragmentTypes () const
| Returns the types of world fragments this query supports.
virtual WorldFragmentType | getWorldFragmentType () const
| Gets the current world fragment types to be returned from the query.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual void | setWorldFragmentType (enum WorldFragmentType wft)
| Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.
Public Member Functions inherited from Ogre::RaySceneQueryListener
virtual | ~RaySceneQueryListener ()

## Additional Inherited Members
Public Types inherited from Ogre::SceneQuery
enum | WorldFragmentType { WFT_NONE , WFT_PLANE_BOUNDED_REGION , WFT_SINGLE_INTERSECTION , WFT_CUSTOM_GEOMETRY , WFT_RENDER_OPERATION }
| This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries. More...
Public Attributes inherited from Ogre::SceneQuery
uint8 | mFirstRq
uint8 | mLastRq

## Detailed Description

Specialises the SceneQuery class for querying along a ray.

## Constructor & Destructor Documentation

## ◆ RaySceneQuery()

Ogre::RaySceneQuery::RaySceneQuery | ( | SceneManager * | mgr | ) |

## ◆ ~RaySceneQuery()

Ogre::RaySceneQuery::~RaySceneQuery | ( |  | ) |
| override

## Member Function Documentation

## ◆ clearResults()

virtual void Ogre::RaySceneQuery::clearResults | ( |  | ) |
| virtual

Clears the results of the last query execution.

Remarks
  You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

## ◆ execute() [1/2]

virtual RaySceneQueryResult & Ogre::RaySceneQuery::execute | ( |  | ) |
| virtual

Executes the query, returning the results back in one list.

Remarks
  This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

Referenced by Ogre::DefaultRaySceneQuery::execute().

## ◆ execute() [2/2]

virtual void Ogre::RaySceneQuery::execute | ( | RaySceneQueryListener * | listener | ) |
| pure virtual

Executes the query and returns each match through a listener interface.

Remarks
  Note that this method does not store the results of the query internally so does not update the 'last result' value. This means that this version of execute is more lightweight and therefore more efficient than the version which returns the results as a collection.

Implemented in Ogre::DefaultRaySceneQuery.

## ◆ getLastResults()

virtual RaySceneQueryResult & Ogre::RaySceneQuery::getLastResults | ( |  | ) |
| virtual

Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

## ◆ getMaxResults()

virtual ushort Ogre::RaySceneQuery::getMaxResults | ( |  | ) | const
| virtual

Gets the maximum number of results returned from the query (only relevant if results are being sorted)

## ◆ getRay()

virtual const Ray & Ogre::RaySceneQuery::getRay | ( |  | ) | const
| virtual

Gets the ray which is to be used for this query.

## ◆ getSortByDistance()

virtual bool Ogre::RaySceneQuery::getSortByDistance | ( |  | ) | const
| virtual

Gets whether the results are sorted by distance.

## ◆ queryResult() [1/2]

bool Ogre::RaySceneQuery::queryResult | ( | MovableObject * | obj,
|  | Real | distance )
| overridevirtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::RaySceneQueryListener.

## ◆ queryResult() [2/2]

bool Ogre::RaySceneQuery::queryResult | ( | SceneQuery::WorldFragment * | fragment,
|  | Real | distance )
| overridevirtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::RaySceneQueryListener.

## ◆ setRay()

virtual void Ogre::RaySceneQuery::setRay | ( | const Ray & | ray | ) |
| virtual

Sets the ray which is to be used for this query.

## ◆ setSortByDistance()

virtual void Ogre::RaySceneQuery::setSortByDistance | ( | bool | sort,
|  | ushort | maxresults = 0 )
| virtual

Sets whether the results of this query will be sorted by distance along the ray.

Remarks
  Often you want to know what was the first object a ray intersected with, and this method allows you to ask the query to sort the results so that the nearest results are listed first.

  Note that because the query returns results based on bounding volumes, the ray may not actually intersect the detail of the objects returned from the query, just their bounding volumes. For this reason the caller is advised to use more detailed intersection tests on the results if a more accurate result is required; OGRE uses bounds checking in order to give the most speedy results since not all applications need extreme accuracy.

Parameters

  sort | If true, results will be sorted.
  maxresults | If sorting is enabled, this value can be used to constrain the maximum number of results that are returned. Please note (as above) that the use of bounding volumes mean that accuracy is not guaranteed; if in doubt, allow more results and filter them in more detail. 0 means unlimited results.

The documentation for this class was generated from the following file:

- OgreSceneQuery.h